import bge
from math import floor
from time import time
from mathutils import Vector
from random import random,randint,shuffle
from collections import OrderedDict,defaultdict
from math import sin,pi
   
#if not "scenes" in own:
bge.logic.sceneDict = dict( (scene.name,scene) for scene in bge.logic.getSceneList()) 
   

DEBUG = True
scene = bge.logic.getCurrentScene() 
cont = bge.logic.getCurrentController()
own = cont.owner

def manipulation():
    d1  = 0.0025
    if not "init" in own:
        
        own["blockSetGenerator"] = None
        own["blockDeleter"] = None
        own["len"] = 200
        sphere = []
        r = 4
        own["rad"] = r
        for x in range(-r,r+1): 
            for y in range(-r,r+1): 
                for z in range(-r,r+1):
                    delta = Vector((x,y,z))
                    if delta.length<r:
                        sphere.append((delta.to_tuple(0)))
        shuffle(sphere)
        own["sphere"] = sphere

        try:
            bge.logic.exampleCubes = {"Concrete":exampleCreator("Concrete")}
        except: return
        own["examples"] = True
        own["init"] = True

        own["generators"] = []


         
    t = time()
    serverShots = bge.logic.serverShots
    for key in list( serverShots.keys() ): 
        shot,generator,tStart = serverShots[key]
        if generator == True:
            if t-tStart>2:
                del serverShots[key]
            continue
        if generator == None:
            serverShots[key][1] = generateRay(Vector(shot.pos), Vector(shot.vector),own["len"],own["rad"])
            generator = serverShots[key][1]
        while time()-t< d1:
            result = next( generator )  
            if type(result) != bool  :
                serverShots[key][1] = removeBlocks(result)
                generator = serverShots[key][1]
            if result == True:
                #del serverShots[key]
                serverShots[key][1] = True
                break
        
        
       
    

        
def floorVect( v ):
    result = (floor(v.x),floor(v.y),floor(v.z))
    return result       
   
def generateRay(pos, vector, length, radius):

    radius     = radius

    unitIntersectSet = OrderedDict( dict() )
   
    setStart, setStep = set(own["sphere"]), set()  

    for v in own["sphere"]:
        setStep.add( floorVect(Vector(v)+vector*radius*1.3))
    setResult = setStart - setStep

    cutSpace = [ Vector(pos) for pos in setResult]
    
   
    yield False
    
    faults = 0
    for i in range(0,int(length/radius)):
        
        midPos = pos + vector*i*radius
        
        if not chunkID( tuple(midPos) ) in bge.logic.globalChunkDict.keys():
            if faults>5:
                break
            faults+=1
        
        for delta in cutSpace:
            yield False                                  
            tempV = midPos+delta
            V = floorVect(tempV)
            cID = chunkID( V )            
            if not cID in unitIntersectSet:
                unitIntersectSet[cID]=[]
            unitIntersectSet[cID].append( V )
                 
       
    yield  unitIntersectSet
    
def c(n,d):
    return 1+0.25*round((sin(n/3+d)**3)*2,2)
    

def chunkID(pos):    
    chunkSize = bge.logic.chunkSize
    return (floor(pos[0]/chunkSize),floor(pos[1]/chunkSize))

def removeBlocks(blockSet):
    if not len(blockSet): return   
    key = None
    obj = None
    matID       =   0
    sceneObjects       =   bge.logic.getCurrentScene().objects

    stone = bge.logic.exampleCubes["Concrete"]
    
    for key in blockSet:

                 
        if obj:
            #print("remove lag")
            obj.replaceMesh(obj.meshes[0])        
        
        donorMesh   =   "wave_{}_{}".format(key[0],key[1])
        if not donorMesh in sceneObjects:
            continue        
        obj         =   sceneObjects[donorMesh]    
        mesh        =   obj.meshes[0]
                
        #if not donorMesh: continue
        globalChunkDict =  bge.logic.globalChunkDict[key]
        freeFaces = globalChunkDict["freeFaces"]
        tempFaces = []
        tempBlocks= []
        for pos in blockSet[key]:

            
            if not pos in globalChunkDict: 
                continue            
            yield False
            
            tempBlocks.append(pos) 
            cube = globalChunkDict[pos]   
            del cube[0]
            tempFaces += ( cube.values() )
            del globalChunkDict[pos] 

            

        for pos in tempBlocks:
            tempFaces = spawnCube(mesh,globalChunkDict,Vector(pos),stone,current=tempFaces)   
            yield False
            if randint(0,1):
                vis = scene.addObject("vis",own,randint(1,10))
                vis.worldPosition,vis.worldOrientation,vis.localScale = pos,(0,0,0),(1,1,1)
                vis.color = (c(pos[0],0),c(pos[1],1.75),c(pos[2],3.75),0.75)
            
        


        for face in tempFaces:            
            for faceIndex in face:
                mesh_vert   =   mesh.getVertex(matID,faceIndex) 
                mesh_vert.setXYZ((0,0,0))
            yield False

        #print( len(globalChunkDict["freeFaces"]))
    if obj:
        #print("remove lag last")
        obj.replaceMesh(obj.meshes[0])

   
    yield True
       


def spawnCube(mesh,chunkDict, pos, exampleCube,current=[]):

    freeFaces   = chunkDict["freeFaces"]

    check_space =[  Vector((0,0,1)),Vector((0,0,-1)),
                    Vector((1,0,0)),Vector((-1,0,0)),
                    Vector((0,1,0)),Vector((0,-1,0))]    

    matID               = 0
    for delta in check_space:

        newPos      = pos+delta
        key         = tuple(newPos)
        faceKey     = tuple(-delta)

        if not key in chunkDict or faceKey in chunkDict[key]:
            continue


        if len(current):
            face        = current.pop()
        elif len( freeFaces):
            face        = freeFaces.pop()
        

        verts,uvs   = exampleCube[faceKey]
        
        for i,vertIndex in enumerate(face):

            mesh_vert   = mesh.getVertex(matID,vertIndex)
            vertPos,uv  = verts[i],uvs[i]
            mesh_vert.setXYZ(newPos+vertPos)
            mesh_vert.setUV(uv)
            mesh_vert.setNormal(faceKey)     
        
        chunkDict[key][faceKey] = face

    return current
    




def exampleCreator(objName):
    """ Creates a uv & vert list of a reference object """


    matID               = 0
    sceneObjects        = scene.objectsInactive
    exampleCube         = sceneObjects[objName]  
    exampleCubeMesh     = exampleCube.meshes[0]    

    exampleDict = {}
    
    #for index in range( mesh.numPolygons ):
   #     face = getPolygon(index)
    vertexAmount = exampleCubeMesh.getVertexArrayLength(0)
    for index in range( 0,vertexAmount,4):
        uvs ,verts  = [], []
        for faceIndex in range(index,index+4):

            mesh_vert   = exampleCubeMesh.getVertex(matID,faceIndex)
            vert_pos    = mesh_vert.getXYZ().copy()
            vert_uv     = mesh_vert.UV.copy()
            uvs.append( vert_uv )
            verts.append( vert_pos )
            normal = mesh_vert.normal
        exampleDict[tuple(normal)] = [verts,uvs]

    return exampleDict

