from bge import logic, events
import mathutils
from time import time
"""
by solarlune
http://blenderartists.org/forum/showthread.php?231836-Simple-Drift-less-Character-Movement-Setup-V2-0-10-19-12-UPDATE
but edited and aranged by vegetablejuice
"""

cont = logic.getCurrentController()
obj = cont.owner
keyboard = logic.keyboard.events
JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
def main():
    # KEY BINDINGS
    kbleft      = events.AKEY
    kbright     = events.DKEY 
    kbforward   = events.WKEY
    kbback      = events.SKEY
    kbJump      = events.SPACEKEY
    sFloor = cont.sensors["Floor"]

    ##################
    if not 'moveinit' in obj:
        obj['moveinit']     = 1
        obj['mv']           = mathutils.Vector()        
        obj['friction']     = 1.0 
        obj['accel']        = 2.0 + obj['friction']
        obj['maxspd']       = 8.0 + obj['friction']
        obj['movelocal']    = 1
        obj['jumpStart']    = str(0)
        obj['jumpDelay']    = 0.3
        obj['jumpCount']    = 0
        obj['jumpTimes']    = 3
        

    if not obj['movelocal']:                      
        obj['mv'].x = obj.worldLinearVelocity.x
        obj['mv'].y = obj.worldLinearVelocity.y
    else:
        obj['mv'].x = obj.localLinearVelocity.x
        obj['mv'].y = obj.localLinearVelocity.y

      
    obj['mv'].magnitude -= obj['friction'] if obj['mv'].magnitude > obj['friction'] else obj['mv'].magnitude
      
    # Taking input       
    if keyboard[kbleft]:
        obj['mv'].x -= obj['accel']
    elif keyboard[kbright]:
        obj['mv'].x += obj['accel']
    if keyboard[kbforward]:
        obj['mv'].y += obj['accel']
    elif keyboard[kbback]:
        obj['mv'].y -= obj['accel']

    currentTime = time() 
    if currentTime-float(obj['jumpStart'])>=obj['jumpDelay'] :
        if sFloor.positive:
            obj['jumpCount']    = obj['jumpTimes']
        if keyboard[kbJump] == JUST_ACTIVATED:# and 
           
            if obj['jumpCount']>0:  
                obj['jumpStart']    = str(time())
                obj['mv'].z         = 3
                obj['jumpCount']   -= 1
        

    obj['mv'].magnitude = min(obj['maxspd'] , obj['mv'].magnitude)

    # Actual movement
        
    if not obj['movelocal']:
        mvz = mathutils.Vector([0, 0, obj.worldLinearVelocity.z])   #   (Add in gravity last)
        obj.worldLinearVelocity = obj['mv'] + mvz                   #   To move globally
    else:
        mvz = mathutils.Vector([0, 0, obj.localLinearVelocity.z])
        obj.localLinearVelocity = obj['mv'] + mvz                   # To move locally
