import bge
from time import time
from mathutils import Vector

def main():
    cont = bge.logic.getCurrentController()
    own = cont.owner
    scene=bge.logic.getCurrentScene()  
    
    
    if not "physInit" in own: 
        own.applyForce((0,0,9.9*3))   
        vel = own.getLinearVelocity()
        own.setLinearVelocity((vel.x,vel.y,0))       
        try:
            bge.logic.globalChunkDict   
            bge.logic.chunkSize        
            bge.logic.manualVisibility 

        except:   
            print("phys init failed")         
            return
        own["physInit"]             = 0
        own["physRefresh"]          = 1        
        own["physPersonalSpace"]    = {}  
        
        #dict for LOD      
        #bge.logic.open_chunks   = {}  
        
        
    globalChunkDict = bge.logic.globalChunkDict#
    trunc = bge.logic.trunc 
    chunkSize = bge.logic.chunkSize
        
    #avoid falling into the void     
    pos = own.worldPosition
    my_chunk_id = trunc(pos.x, pos.y,chunkSize) 
    if not my_chunk_id in globalChunkDict:        
        own.applyForce((0,0,9.8*3))
        vel = own.getLinearVelocity()
        own.setLinearVelocity((vel.x,vel.y,0)) 
   
          
    def activate_phys(pos):
        pos         =  round(pos[0]),round(pos[1]),int(pos[2])
        c_x,c_y,c_z = pos
        posVect = Vector(pos)
       
        n = 2   
        for x in range(-n+1,n):    
            for y in range(-n+1,n):    
                for z in range(-n+1,n):
                    #deltaVect = Vector()
                    physChunk = trunc(c_x+x,c_y+y,chunkSize)
                    if physChunk in globalChunkDict:
                        currentChunk = globalChunkDict[physChunk]
                        
                        if (c_x+x,c_y+y,c_z+z) in currentChunk:

                            if (c_x+x,c_y+y,c_z+z)  not in   own["physPersonalSpace"]:
                                type = "phys"
                                
                                #plants should only have no_colision box for raycasting 
                                if currentChunk[(c_x+x,c_y+y,c_z+z)][0] == 5:
                                    type = "ghost"                           
                                        
                                block = scene.addObject(type, own)    
                                block.worldPosition=(c_x+x,c_y+y,c_z+z)
                                block.worldOrientation=(0,0,0)
                               
                                own["physPersonalSpace"][ (c_x+x,c_y+y,c_z+z) ] = [block,own["physRefresh"]]                            
                            else:
                                own["physPersonalSpace"][ (c_x+x,c_y+y,c_z+z) ][1] = own["physRefresh"] 

    
    def update_chunk_visibility(chunk_id):
        
        #bge.logic.open_chunks
        #one character instance, needs to be global 
        n = bge.logic.manual_visibility      
        for x in range(-n+1,n):
            for y in range(-n+1,n):
                if  (chunk_id[0]+x,chunk_id[1]+y) in chunk_dict:           
                    bge.logic.open_chunks[(chunk_id[0]+x,chunk_id[1]+y)] = own["physRefresh"]
                    bge.logic.chunk_dict[(chunk_id[0]+x,chunk_id[1]+y)].setVisible( 1)                   
        for i in list(bge.logic.open_chunks):
            if bge.logic.open_chunks[i] != own["physRefresh"]  :
               bge.logic.chunk_dict[i].setVisible( 0 )     
               bge.logic.open_chunks.pop(i) # should use a delay 
                
                        
   
      
    
    
    own["physRefresh"] = round(time())
    
    pos = own.worldPosition.copy()
    topos = pos.copy()

    vel = own.getLinearVelocity()
    
    topos.x += 5*vel[0] / bge.logic.getLogicTicRate()
    topos.y += 5*vel[1] / bge.logic.getLogicTicRate()
    topos.z += 5*vel[2] / bge.logic.getLogicTicRate()
    
        
                
    activate_phys(pos)
    activate_phys(topos)
                
    for i in list(own["physPersonalSpace"]):       
        if own["physRefresh"]-own["physPersonalSpace"][i][1] > 1 :
           own["physPersonalSpace"][i][0].endObject()
           own["physPersonalSpace"].pop(i)  
     
              
    if  bge.logic.manualVisibility:
        my_chunk_id = bge.logic.trunc(pos.x, pos.y,bge.logic.chunkSize)           
        update_chunk_visibility(my_chunk_id)                            
#main()      

