from sys import argv
from subprocess import Popen    
import socket
from os import path,listdir,unlink
try:
    from bge import logic
except:
    print("not in game engine")
import time


# import os,sys
# sys.stdout = open(os.devnull, "w")

class Popen_curse:
    """
    Kills process when
    garbage collector(game exit) starts
    """
    def __init__(self,obj):
        self.obj =  obj
    def __del__(self):
        #if delete event do this:
        #print( "Popen_curse " )
        Popen.kill(self.obj)

class Map_curse:
    """
    Deletes any file created in the local map folder;
    after savegame implementation this is not needed.
    """
    def clear_folder(self):        
        folder = logic.expandPath("//")        
        folder = path.join(folder, "map\\")
        
        for the_file in listdir(folder):
            file_path = path.join(folder, the_file)
            try:
                if path.isfile(file_path):
                    unlink(file_path)
            except:
                print( "error deleting file")             
        #print(" FOlders are cleaned " )
    def __del__(self):       
        #if delete event do this:
        self.clear_folder()

def launch():
    """
    Popens,meaning to open with Popen,
    everything needed for
    socket driven realtime mesh creation.
    """
    cont    = logic.getCurrentController()
    own     = cont.owner
    
    blender_path    = argv[0]
    local_path      = logic.expandPath("//")

    print( "Debug blender path:",blender_path )
    print( "Debug local path:", local_path  )
    if "blenderplayer" in blender_path:
        blender_path = blender_path.replace( "blenderplayer", "blender" )
        print("ATTENTION!!!\nDebug new blender path:",blender_path )

    """ Try if server is open """

    s = socket.socket()
    address = '127.0.0.1'
    port = 9999 # port number is a number, not string
    isOpen = True
    try:
        s.connect((address, port)) 
    except :
        print("\n\nLocal mesh creation server willbe opened\n\n")        
        isOpen = False
    s.close()

    if not isOpen:

        folderPath = path.join(local_path, "mapCreationLogic")
        
        server  = Popen( [blender_path, "--background", path.join(local_path, "worker.blend"), "-P", path.join(folderPath, "server.py")])

        workers = []
        for i in range( own["workers"] ):
            #should delay a little
            worker = Popen( [blender_path, "--background", path.join(local_path, "worker.blend"), "-P", path.join(folderPath, "operator_worker_client.py")])
            workers.append(worker)

        
        logic.workers       = [Popen_curse(worker) for worker in workers]     
        logic.server        = Popen_curse(server)
        if own["enable_delete_map"]:
            logic.map_cleanup   = Map_curse() # clutter  deleter

    time.sleep(1)
    
    
    own["server"] = True
