from socket import *
import time
import mesh_creation_suite
import pickle,zlib

# import os,sys
# sys.stdout = open(os.devnull, "w")

class client():
    def __init__(self, name="W",HOST='127.0.0.1',PORT=9999,BUFSIZ=8192):
        self.name   = name
        self.HOST   = HOST
        self.PORT   = PORT
        self.BUFSIZ = BUFSIZ
    def __del__(self):
        # in case of process close
        self.kill()                
    def kill(self):
        print(self.name,": Client killed.")
        try:
            # notifiy the server of the demise
            data = bytes("/dead","UTF-8")
            self.socket.send(data)
        except:
            print(self.name,": Server dead")
        time.sleep(1/10)
        self.socket.close()
        
    def run(self):        
        ADDR        = (self.HOST, self.PORT)
        tcpCliSock  = socket(AF_INET, SOCK_STREAM)
        self.socket = tcpCliSock        
        COMPRESSION = True
        while 1:
            try:
                tcpCliSock.connect(ADDR)        
                break
            except ConnectionRefusedError:
                print("Worker:    Connection Refused / No server.\n    ( Lags are from retrying to connect )")
            for i in range(30*2): # wait a couple of ticks
                yield True 
    
        initalWorkerState  = {"init":True, "state":1,"name":self.name,"builtChunks":set()}        
       
        data = pickle.dumps(initalWorkerState)
        if COMPRESSION: data = zlib.compress(data)          
        tcpCliSock.send(data) 
        
        while 1:
            try:
                response        = tcpCliSock.recv(self.BUFSIZ)
            except:
                print("worker lost connection to server->end of service:",self.name)
                self.kill()
                yield False
                break
           
            if COMPRESSION: response = zlib.decompress(response)
           
            response  =   pickle.loads(response)
            
            seed = response["seed"]
            chunkSize = response["chunkSize"]

            done = []           
            for work in response["work"]:
                x,y = work
                mesh_creation_suite.create_mesh(x,y,seed,chunkSize)
                done.append(work)
            # if len(done): print("WORKER done WORK",done)
            workerState  = {"state":"alive","name":self.name,"builtChunks":set(done)}
            data = pickle.dumps(workerState)
            if COMPRESSION: data = zlib.compress(data)          
            tcpCliSock.send(data)     
                
            if response["health"] in ["/kill","/dead"]: break        
            yield True
        
        print(self.name,response,"mass suicide")
        self.kill()
        yield False
