from socket import * 
from threading import *
from time import time
from random import choice
import os, sys, inspect

#get to the script folder
path = os.path.abspath(__file__).replace( os.path.basename(__file__),"")
sys.path.append ( path ) 
sys.path.append ( path.replace("\\"+path.split("\\")[-2],"")) 


from structures import *
from serverSettings import *


DEBUG           = 0

seeds = ["CupCakes","KimJongUn","CuttleFish","SnakesOnAPlane"]
string = choice(seeds)
seed            = ''.join(random.sample(string,len(string))) # 
serverHealth    = "Happy"
lock            = Lock()
freeID          = 0
freedIDS        = []
freeSpace       = FREE_SPACE


serverDict = {"players":{},"shots":{}}

def updateDict(newValues,targetDict):
    currentTime = time() 
    for obj in newValues:
        targetDict[ obj.id ] = (obj,currentTime)            
    #types = [ obj for obj,birth in targetDict.values() if currentTime-birth<TIME_OUT ]
    types = []
    for key in list(targetDict.keys()):
        obj,birth = targetDict[key]
        if currentTime-birth>TIME_OUT:
            del targetDict[key]
        else: types.append(obj)
    return types

def handler(clientsock,addr,BUFSIZ):
    # access shared parameters
    global serverHealth, lock,pendingTasks,doneTasks,seed,inWorkTasks
    global chunkSize,freeID,freeSpace
    

    lock.acquire()
    if len(freedIDS):
        myID = freedIDS.pop()
    else:
        myID        = freeID
        freeID     += freeSpace
    lock.release()

    welcome     = Welcome(myID,freeSpace,seed)
    print( seed,welcome.seed)
    clientsock.send(welcome)   


    while 1:
        try:
            data = clientsock.recv(BUFSIZ)                
        except :
            print("Forcibly closed by the remote host",(myID))
            if myID in serverDict["players"]:
                lock.acquire()
                serverDict["players"][ myID ][0].id *= -1  
                freedIDS.append(myID)        
                lock.release()
                print("Now considered dead",(myID))                
            break           

        players,shots = translate( data )
          
        ######################
        lock.acquire()
  
        playersList     = updateDict(players,serverDict["players"])
        shotsList       = updateDict(shots,serverDict["shots"])        

        lock.release()
        ####################


        packet = packPacket(playersList,shotsList)

        
        clientsock.send(packet)

              

             
    print('Connection terminated',(myID))
    clientsock.close()
    

def start_server():
    
    HOST = gethostbyname(gethostname())    
    BUFSIZ = 1024
    ADDR = (HOST, PORT)

    print("ADDR:   ",ADDR,"\n\n")


    serversock = socket(AF_INET, SOCK_STREAM)
    serversock.bind(ADDR)
    serversock.listen(10)

    while serverHealth == "Happy":
        lock.acquire()
        print( "waiting for connection…")
        lock.release()
        clientsock, addr = serversock.accept()
        lock.acquire()
        print( "…connected from:", addr)
        lock.release()
        t = Thread(target=handler,  args=[clientsock, addr,BUFSIZ])
        t.start()
        
        
print("\n\n    Server START\n\n")

start_server()
